Page MenuHomePhabricator

Capture Time to meaningful first content ("Time to text") in RUM or WebPageTest
Closed, DeclinedPublic

Description

We have both RUM & synthetic testing up and running we should start to focus on what to measure and find metrics that means something for the user and are easy to communicate.

When the article text is showed for the user. Maybe when the article headline is shown? "Time to text"?

Upstream Google has been working on a "First Meaningful Paint" in Lighthouse:
https://developers.google.com/web/tools/lighthouse/audits/first-meaningful-paint

They're also working on exposing this through a new Paint Timing API.
https://www.chromestatus.com/feature/5688621814251520
https://wicg.github.io/paint-timing/

EDIT: This has been released in Chrome 60.
https://developers.google.com/web/updates/2017/07/nic60#paint

See also:

Event Timeline

Peter created this task.Dec 10 2015, 7:13 PM
Peter raised the priority of this task from to Needs Triage.
Peter updated the task description. (Show Details)
Peter added a project: Performance-Team.
Peter added subscribers: Peter, Krinkle.
Restricted Application added subscribers: StudiesWorld, Aklapper. · View Herald TranscriptDec 10 2015, 7:13 PM
Peter added a comment.Dec 11 2015, 7:20 AM

I did a couple fast tests yesterday with the only pages I know that implements user timings for content and images: webpagetest.org and www.sitespeed.io.

When I look in WebPageTest "The time to text" always seems off (or at least not showing the exact same numbers) but the the time to first image looks better, but I haven't tested it fully in different browsers and connection speeds.

Let put this on hold. We tried out user timings for measuring image time and it worked out bad: T115600

The Chrome team is planning to include SpeedIndex in the browser: https://groups.google.com/a/chromium.org/forum/#!topic/loading-dev/E9FIy0B2AkU

In the webperformance slack channel Pat Meenan said that they plan to also make it reachable from JS (when it's battle tested). That would be great for us.

Peter added a comment.Nov 23 2016, 9:17 AM

Got some updates: It seems the Chrome team stopped working on SpeedIndex but the w3c working group has a proposal for firstMeaningfulPaint (images/text/svg). This is implemented in Chrome event logs but not availible in JS yet. Firefox also have intentions to implement it https://bug635044.bugzilla.mozilla.org/show_bug.cgi?id=1298381 (a lot interesting links in that issue).

Peter added a comment.Nov 23 2016, 9:44 AM

This is the issue we should keep track of: https://github.com/w3c/charter-webperf/issues/32

Peter added a comment.Nov 23 2016, 9:54 AM

But for us I think the current firstPaint will be the same as the firstManingfulPaint. Checkout https://github.com/tdresser/time-to-first-paint/blob/master/README.md and for us in Chrome (at least) the page render like this:

First there's nothing:

And then the first real paint:

First image:

Logo:

Krinkle updated the task description. (Show Details)Dec 7 2016, 7:34 PM
Krinkle set Security to None.
Gilles triaged this task as Normal priority.Dec 7 2016, 7:34 PM
Gilles raised the priority of this task from Normal to High.Dec 7 2016, 7:36 PM
Gilles lowered the priority of this task from High to Normal.
Gilles added a project: Upstream.
Krinkle renamed this task from New metrics for performance to New page timing metrics.Dec 7 2016, 7:37 PM
Krinkle renamed this task from New page timing metrics to Capture "Time to text" (time to meaningful content?) in RUM or WebPageTest.Jul 1 2017, 2:06 AM
Krinkle updated the task description. (Show Details)
Krinkle renamed this task from Capture "Time to text" (time to meaningful content?) in RUM or WebPageTest to Capture Time to meaningful first content ("Time to text") in RUM or WebPageTest.Aug 5 2017, 11:16 PM
Krinkle updated the task description. (Show Details)Aug 5 2017, 11:18 PM

(Removed #Upstream tag as this has been unblocked, Chrome released it, see updated task description.)

I think this still doesn't work as expected in Chrome (it's released I know, but ...) see:
https://codereview.chromium.org/2967733002/
https://chromium-review.googlesource.com/c/576371

Imarlier closed this task as Declined.Jan 18 2018, 4:00 PM
Imarlier added a subscriber: Imarlier.

Will partially pursue via T179619